﻿import std.cstream;
import std.thread;
import std.date;
import hdk.sdlmixer;
import std.utf;

int main()
{
	try
	{
		// スレッドセーフかどうか試す
		A a = new A();
		
		const dchar[]
			SE0 = `..\resource\se0.ogg`,
			SE1 = `..\resource\se1.ogg`,
			BGM0 = `..\resource\bgm0.ogg`,
			BGM1 = `..\resource\bgm1.ogg`;
		//auto SdlMixerTest test = new SdlMixerTest();
		//with (test)
		{
			waitEnter(`playBgm("bgm0.ogg");`);
			dout.writeLine("hoge");
			dout.writeLine(toUTF8(SE0));
			playBgm(BGM0);
			waitEnter(`playBgm("bgm1.ogg");`);
			playBgm(BGM1);
			
			waitEnter(`playSe("se0.ogg");`);
			playSe(SE0);
			waitEnter(`playSe("se1.ogg");`);
			playSe(SE1);
			waitEnter(`playSe("se0.ogg");`);
			playSe(SE0);
			
			waitEnter(`stop();`);
			stop();
			
			waitEnter(`playSe("se1.ogg");`);
			playSe(SE1);
			
			waitEnter(`playVoice("se0.ogg");`);
			playVoice(SE0);
			waitEnter(`playVoice("se0.ogg");`);
			playVoice(SE0);
			waitEnter(`playVoice("se1.ogg");`);
			playVoice(SE1);
			waitEnter(`playVoice("se0.ogg");`);
			playVoice(SE0);
			a.wait();
			
			waitEnter(`stop();`);
			stop();
		}
	}
	catch (Exception e)
	{
		derr.writeLine("Exception: " ~ e.toString());
	}
	return 0;
}

void waitEnter(char[] text)
{
	dout.writeString(text);
	din.readLine();
}

class A : Thread
{
	this() { start(); }
	
	int run()
	{
		const dchar[] SE0 = `..\resource\se0.ogg`;
		const dchar[] SE1 = `..\resource\se1.ogg`;
		for (int i = 0; i < 5; i++)
		{
			playSe(SE0);
			dout.writeLine("sub thread play se");
			dout.flush();
			sleep(1);
		}
		dout.writeLine("sub thread end");
		return 0;
	}
	
	void sleep(uint second)
	{
		d_time n = getUTCtime() / TicksPerSecond;
		while (true)
		{
			yield();
			if (getUTCtime() / TicksPerSecond - n >= second) break;
		}
	}
}
