﻿import std.cstream;
import hdk.sdlbase;
import hdk.oglbase;
import hdk.oglshader;
import hdk.oglvertexbuffer;
import hdk.ogltexture;
import hdk.math;

int main()
{
	try
	{
		//auto OglBaseTest base = new OglBaseTest();
		//OglTextureMapTest.execute();
		//OglVertexBufferMapTest.execute();
		OglShaderMapTest.execute();
		dout.writeLine("ok");
	}
	catch (Exception e)
	{
		derr.writeLine("Exception: " ~ e.toString());
	}
	return 0;
}

auto class SdlBaseTest { mixin SdlBase; }

interface _OglBase
{
	void clear();
	void drawArrays(uint vertexLength);
	void setProjectionMatrix(float* f4x4);
	void setModelViewMatrix(float* f4x4);
	void depthTestWriting(bit test, bit writing);
	void cullingEnableFront(bit enable, bit front);
	uint[] readBackBuffer(uint width, uint height);
}

auto class OglBaseTest : SdlBaseTest, _OglBase
{
	mixin OglBase;
}
